declare type Chord = string;
declare type ChordID = number;
declare type Shortcut = string;
declare type ShortcutID = ChordID[];
declare type RecordHandler = (shortcut: Shortcut) => any;
declare type ListenerOptions = {
    handler: (id: ShortcutID, event: KeyboardEvent) => import('./enums').ListenerResult | ShortcutID;
    target?: Node;
};
declare type ShortcutsOptions = {
    shortcuts?: ShortcutDescriptor[];
    target?: Node;
};
declare type ShortcutsTree = {
    [id: number]: ShortcutsTree;
    parent?: ShortcutsTree;
    id?: ChordID;
    size: number;
    handlers: Function[];
};
declare type ShortcutDescriptor = {
    handler?: (event: KeyboardEvent) => boolean | void;
    shortcut: string;
};
